#ifndef SEILBOT_H

#define SEILBOT_H
/*
 * Backward Kinematics für Seilbot mit 4 Seilen
 *
 */



class Seilbot
{
    public:
    double A = 474.0; // Breite , Länge des Gerüsts
    double B = 500.0; // Höhe des Gerüsts
    double c=45;     // Breite des gleichseitigen Endeffektors
    double d=15;     // Dicke des Endeffektors
    double m,g;   // Abschnitte der Mittelsenkrechte: m:Mitte-Spitze, g: Mitte-Seite

    double delta=1;   // Fadendurchmesser
    double r=7.8;     // Durchmesser Wickelrolle
    double lpr = 0;   // Längeneinzug bei einer Umdrehung der Wickelrolle
    double cpr = 235; // Motor-Encoder: Counts per revolution

    double l1_0,l2_0,l3_0,l4_0;
    double x,y,z;
    double x0,y0,z0;
    double factor=1.0;
    
    Seilbot(double A,double B, double c, double d, double delta, double r, int cpr);    
    void calcLengths(double x, double y, double z, double * l1,double * l2, double *l3, double * l4);
    int  lenToCounts(double dl);
    void calcDeltaLengths(double x, double y, double z, double * l1,double * l2, double *l3, double * l4);
    void calcDeltaCounts(double x, double y, double z, int *c1, int * c2, int *c3, int*c4);
    void setZeroPosition(double x0,double y0, double z0);
    void setPos(double x, double y, double z);
    void setFactor(double f);
};

#endif
