import matplotlib.pyplot as plt
from casadi import cos, sin,Function,rootfinder,vertcat
from math import pi ,degrees,radians
import numpy as np
import casadi
import sys

def minimize():

  u = 7   # proximal arm length
  v = 12  # x/2 Tilt Platform
  w =  8  # y/2 Tilt Platform
  r = 19  # x-pos Actuator
  h  = 8  # z-pos Actuator
  hs = 7  # central ball joint Tilt Platform
  l = 5   # distal arm length

  opts = {'ipopt.print_level': 0, 'print_time': 0}
  actangle = casadi.SX.sym("actangle",2)
  tiltangle = casadi.SX.sym("tiltangle",2)

  phi= tiltangle[0]
  theta=tiltangle[1]
  alpha=actangle[0]
  beta=actangle[1]

  #casadi.sin

  
  p_m = [ -v*cos(theta), - v * sin(phi)* sin(theta) - w * cos(phi), +v * cos(phi)*sin(theta) - w * sin(phi)+ hs]
  p_p = [ +v*cos(theta), + v * sin(phi)* sin(theta) - w * cos(phi), -v * cos(phi)*sin(theta) - w * sin(phi)+ hs]
  
 # q_m = [ - u * sin(alpha) - r, -w, u * cos(alpha) + h ]
 # q_p = [ - u * sin(beta)  + r, -w, u * cos(beta) + h ]
  q_m = [  u * cos(alpha) - r, -w, -u * sin(alpha) + h ]
  q_p = [  u * cos(beta)  + r, -w, -u * sin(beta) + h ]


  eq_m = (p_m[0] - q_m[0])**2 +(p_m[1] - q_m[1])**2 + (p_m[2]-q_m[2])**2 - l**2
  eq_p = (p_p[0] - q_p[0])**2 +(p_p[1] - q_p[1])**2 + (p_p[2]-q_p[2])**2 - l**2

  aa1 = (actangle[0] - 0.5)
  aa2 = (actangle[1] - 0.5)

  cleq = eq_m **2 + eq_p ** 2

  print(cleq)
  #nlp = {'x': phi , 'f':  cleq, 'p': beta}

  # first: caclulate Zero-Position:
  nlp = {'x': actangle, 'f':  cleq, 'p': tiltangle}
  nlp_solver = casadi.nlpsol('backward', 'ipopt', nlp, opts)
  x0old = [0.1,0.1]
  solution = nlp_solver(x0=x0old, p=[0,0])
  r= np.array( solution['x'] )
  print( degrees(r[0]), degrees(r[1]))

  am = r[0]
  ap = r[1]

  nlp = {'x': tiltangle, 'f':  cleq, 'p': actangle}
  n=15

  darange = pi/4
  xarr=[]
  yarr=[]
  zarr=[]
  #dbs = [-radians(20),-radians(20),-radians(10),0,radians(10),radians(20),radians(20) ] 
  #dbs = [ -degrees(30),-degrees(25), -0.2, -0.1,0 , 0.1 , 0.2, degrees(25)] 
  dbs = [ -0.2, -0.1,0 , 0.1 , 0.2 ] 
  #dbs = [ 0 ] 

  print(actangle)
  
#  g = Function('g',[vertcat(tiltangle),vertcat(actangle)], [vertcat(eq_m,eq_p)] )
#  opts={}
#  G=rootfinder("G", "newton", g, opts)
#  print(G([0,0],[0.2,0.2]))

  x0old = [0.2,0.2]
  for j in range(0,len(dbs)):
      db = -darange / 2 + j/n * darange
      db=dbs[j]
      print()
      yarr.append([])
      zarr.append([])
      for i in range(0,n+1):
         da =  -darange /  2 + i/n * darange 
         if(len(xarr)<=n):
             xarr.append(degrees(da))
         nlp_solver = casadi.nlpsol('forward', 'ipopt', nlp, opts)
         x0old = [0.1,0.1]
#         solution = nlp_solver(x0=x0old, p=[am-db+da,ap+db+da])
         solution = nlp_solver(x0=x0old, p=[am-da+db,ap+da+db])
         r= np.array( solution['x'] )

         yarr[j].append(degrees(r[0]))
         zarr[j].append(degrees(r[1]))
         x0old= r
         print( degrees(da), degrees(db), degrees(am-da),degrees(ap+da), degrees(r[0]), degrees(r[1]))


  nxarr = np.array(xarr)
  print(len(xarr),len(yarr[0]))
  for k in range(0,len(yarr)):
      print(k,len(yarr))
      nyarr = np.array(yarr[k])
      nzarr = np.array(zarr[k])
#      plt.suptitle('Tilt angles in dependence of antiphase acutator angle')
      #plt.suptitle('Plattform-Kippwinkel in Abh. von gleichsinnigem Aktuator-Winkel')
      plt.suptitle('Plattform-Kippwinkel in Abh. von gegensinnigem Aktuator-Winkel')
      plt.ylim(-20,20)
      plt.plot(nxarr,nyarr,'b',label='phi')
      plt.plot(nxarr,nzarr,'g',label='theta')

  plt.grid()
  plt.show()

minimize()
