import matplotlib.pyplot as plt
from casadi import asin, cos, sin,sqrt,Function,rootfinder,vertcat
from math import pi ,degrees,radians
import numpy as np
import casadi
import sys

def minimize():

  u = 7   # proximal arm length
  v = 12  # x/2 Tilt Platform
  w =  8  # y/2 Tilt Platform
  r = 19  # x-pos Actuator
  h  = 8  # z-pos Actuator
  hs = 7  # central ball joint Tilt Platform
  l = 5   # distal arm length

  opts = {'ipopt.print_level': 0, 'print_time': 0}
  actangle = casadi.SX.sym("actangle",2)
  tiltangle = casadi.SX.sym("tiltangle",2)

  sp=tiltangle[0]
  st=tiltangle[1]
  sa=actangle[0]
  sb=actangle[1]

  #casadi.sin
  # sp = sin(phi)
  # cp = cos(phi) = sqrt(1-sp**2)
  # st = sin(theta)
  # ct=  cos(theta) = sqrt(1-st**2)

  cp = sqrt(1-sp**2)
  ct = sqrt(1-st**2)
  ca = sqrt(1-sa**2)
  cb = sqrt(1-sb**2)
# Rx: rot um x
# 1          0            0
# 0          cos(phi)   -sin(phi)
# 0          sin(phi)    cos(phi)
#
# Ry: rot um y
# cos(theta)   0         -sin(theta)
# 0          1            0
# sin(theta)   0          cos(theta)
#
#  Rx * Ry 
#  
#
  p_m = [ - v * ct, - v * sp * st - w * cp, + v * cp * st - w * sp + hs]
  p_p = [ + v * ct, + v * sp * st - w * cp, - v * cp * st - w * sp + hs]
  
  #q_m = [ + u * sa  - r, -w, u * ca  + h ]
  #q_p = [ + u * sb  + r, -w, u * cb  + h ]
  q_m = [ + u * ca  - r, -w, - u * sa  + h ]
  q_p = [ + u * cb  + r, -w, - u * sb  + h ]

  print("p_m=", p_m)
  p= Function('p_m',[st,sp],p_m )
  print("p=", p)

# closing equations:
  eq_m = (p_m[0] - q_m[0])**2 +(p_m[1] - q_m[1])**2 + (p_m[2]-q_m[2])**2 - l**2
  eq_p = (p_p[0] - q_p[0])**2 +(p_p[1] - q_p[1])**2 + (p_p[2]-q_p[2])**2 - l**2

  cleq = eq_m **2 + eq_p ** 2

  print(cleq)
  #nlp = {'x': phi , 'f':  cleq, 'p': beta}

  # first: caclulate Zero-Position:
  nlp = {'x': actangle, 'f':  cleq, 'p': tiltangle}
  nlp_solver = casadi.nlpsol('backward', 'ipopt', nlp, opts)
  #x0old = [degrees(35),degrees(180-35)]
  #x0old = [degrees(35),degrees(35)]
  x0old = [sin(degrees(20)),sin(degrees(180-20))]
  solution = nlp_solver(x0=x0old, p=[0,0])
  r= np.array( solution['x'] )
  print( degrees(asin(r[0])), degrees(asin(r[1])))

  am = asin(r[0])
  ap = asin(r[1])

  nlp = {'x': tiltangle, 'f':  cleq, 'p': actangle}
  n=15

  darange = pi/4
  xarr=[]
  yarr=[]
  zarr=[]
  #dbs = [-radians(20),-radians(20),-radians(10),0,radians(10),radians(20),radians(20) ] 
  x0old = [0.4,0.4]
  dbs = [  degrees(0.0) ] 

  print(actangle)
  
  #
  # am,ap = Actuator angles for which  tilt platform is horizontal
  # da    = anti mode angle    -> theta tilt 
  # db    = common mode angle  -> phi tilt
  #
  for j in range(0,len(dbs)):
      db=dbs[j]
      print()
      yarr.append([])
      zarr.append([])
      for i in range(0,n+1):
         x0old = [0.4,0.4]
         da =  ( -darange /  2 + i/n * darange )
         if(len(xarr)<=n):
             xarr.append(degrees(da))
         nlp_solver = casadi.nlpsol('forward', 'ipopt', nlp, opts)
         solution = nlp_solver(x0=x0old, p=[sin(am-da+db),sin(ap+da+db)])
         r= np.array( solution['x'] )

         yarr[j].append(degrees(asin(r[0])))
         zarr[j].append(degrees(asin(r[1])))
         x0old= r
         print( degrees(da), degrees(db), degrees(am-da),degrees(ap+da), degrees(asin(r[0])), degrees(asin(r[1])))
#         print('f=',p( r,[0,0])) 


  nxarr = np.array(xarr)
  print(len(xarr),len(yarr[0]))
  for k in range(0,len(yarr)):
      print(k,len(yarr))
      nyarr = np.array(yarr[k])
      nzarr = np.array(zarr[k])
      plt.plot(nxarr,nyarr,'b',label='phi')
      plt.plot(nxarr,nzarr,'g',label='theta')

  plt.grid()
  plt.show()

minimize()
