from casadi import *  
import math

# variables
x = SX.sym('x',1)
y = SX.sym('y',1)

# parameters
la = SX.sym('la',1)
lb = SX.sym('lb',1)
params=[la,lb]

#equations
g0 = la - sqrt( x**2 + y**2)
g1=  lb - sqrt( (10-x)**2 + y**2)


                  # Variables  Paraemters         Equateions
g = Function('g',[vertcat(x,y),vertcat(*params)],[vertcat(g0,g1)])
opts = {}
opts["nlpsol"] = "ipopt"
opts["nlpsol_options"] = {"ipopt.tol":1e-14}
G=rootfinder("G", "nlpsol", g, opts)

#G = rootfinder('G','nlpsol',g,{'nlpsol':'ipopt'})

#G = rootfinder('G','newton',g)
print(G)
      # start  #parameter 

iparams=[x,y]
                  # Variables  Paraemters         Equateions
gi = Function('gi',[vertcat(la,lb),vertcat(*iparams)],[vertcat(g0,g1)])
Gi=rootfinder("Gi", "nlpsol", gi, opts)
# Vorgabe     Koordinaten => Längen
soli=Gi([2,2],[2,40])

print("Soli (Längen):")
print((soli))

# Vorgabe     Längen => Koordinaten
sol=G([2,2],soli)


print("Sol (Koordinaten):")
print((sol))
# Längen aus Koordinaten zu fuß:
print("l=",math.sqrt(sol[0]**2+sol[1]**2))
print("l=",math.sqrt((10-sol[0])**2+sol[1]**2))
print("Soli (Längen):")
print((soli))
